/*
 *    Attribute.java
 *    Copyright (C) 1999 Pierre Geurts
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

import java.io.*;

abstract class Attribute{
  /* the name of the attributes */
  String name;
  /* the database of the attributes */
  Database db;
  /* attribute index in the database */
  int index;
  /* the lastbestscore of this attribute */
  double lastbestscore;

  public Object Value(Obj o) {
    return o.attributesvalues.elementAt(index);
  }
  abstract void SetAttValue(Obj o,Object s);
  public String toString() {
     return name;
  }
  abstract String describe();
  abstract String describeBestTest();
  abstract int ReadAttValue(Obj o,StreamTokenizer stt);
  // compute the best score we can obtain with this attribute
  abstract double bestscore(ObjectSet os, SymbAtt goal);
  // effectively compute the partition resulting from this best score
  abstract Partition bestpartition(ObjectSet os, SymbAtt goal);
}
